# SoVRMLGroup Class Reference
[VRML97 classes]

`#include <Inventor/VRMLnodes/SoVRMLGroup.h>`

Inheritance diagram for SoVRMLGroup:

List of all members.

## Detailed Description

The SoVRMLGroup class is used for grouping VRML nodes.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      Group {
        eventIn      MFNode  addChildren
        eventIn      MFNode  removeChildren
        exposedField MFNode  children      []
        field        SFVec3f bboxCenter    0 0 0     # (-inf,inf)
        field        SFVec3f bboxSize      -1 -1 -1  # (0,inf) or -1,-1,-1
      }

A Group node contains children nodes without introducing a new transformation. It is equivalent to a Transform node containing an identity transform. More details on the children, addChildren, and removeChildren fields and eventIns can be found in 4.6.5, Grouping and children nodes (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.5>).

The bboxCenter and bboxSize fields specify a bounding box that encloses the Group node's children. This is a hint that may be used for optimization purposes. The results are undefined if the specified bounding box is smaller than the actual bounding box of the children at any time. A default bboxSize value, (-1, -1, -1), implies that the bounding box is not specified and, if needed, is calculated by the browser. A description of the bboxCenter and bboxSize fields is contained in 4.6.4, Bounding boxes (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.4>).

## Public Types

enum | CacheEnabled { OFF, ON, AUTO }

## Public Member Functions

| SoVRMLGroup (void)
| SoVRMLGroup (int numChildren)
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | notify (SoNotList *list)

## Static Public Member Functions

void | initClass (void)
void | setNumRenderCaches (int num)
int | getNumRenderCaches (void)

## Public Attributes

SoSFEnum | renderCaching
SoSFEnum | boundingBoxCaching
SoSFEnum | renderCulling
SoSFEnum | pickCulling
SoSFVec3f | bboxCenter
SoSFVec3f | bboxSize

## Protected Member Functions

virtual | ~SoVRMLGroup ()
virtual SbBool | cullTest (SoState *state)

## Static Protected Attributes

int | numRenderCaches = 2

## Constructor & Destructor Documentation

SoVRMLGroup::SoVRMLGroup | ( | void |  | ) |

| Constructor.

SoVRMLGroup::SoVRMLGroup | ( | int | numchildren | ) |

| Constructor. numchildren is the expected number of children.

SoVRMLGroup::~SoVRMLGroup | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLGroup::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoVRMLParent. Reimplemented in SoVRMLCollision, and SoVRMLTransform.

void SoVRMLGroup::setNumRenderCaches | ( | int | num | ) | `[static]`

| Set the maximum number of render caches per group node.

int SoVRMLGroup::getNumRenderCaches | ( | void |  | ) | `[static]`

| Returns the maximum number of render caches per group node.

void SoVRMLGroup::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoVRMLParent. Reimplemented in SoVRMLTransform.

void SoVRMLGroup::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoGroup. Reimplemented in SoVRMLTransform.

void SoVRMLGroup::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoGroup. Reimplemented in SoVRMLCollision.

void SoVRMLGroup::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoGroup.

Reimplemented in SoVRMLTransform.

void SoVRMLGroup::getMatrix | ( | SoGetMatrixAction * | action | ) | `[virtual]`

| Action method for SoGetMatrixAction. Updates action by accumulating with the transformation matrix of this node (if any). Reimplemented from SoGroup. Reimplemented in SoVRMLTransform.

void SoVRMLGroup::rayPick | ( | SoRayPickAction * | action | ) | `[virtual]`

| Action method for SoRayPickAction. Checks the ray specification of the action and tests for intersection with the data of the node. Nodes influencing relevant state variables for how picking is done also overrides this method. Reimplemented from SoNode. Reimplemented in SoVRMLTransform.

void SoVRMLGroup::search | ( | SoSearchAction * | action | ) | `[virtual]`

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction -- if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also:
  SoSearchAction

Reimplemented from SoVRMLParent.

void SoVRMLGroup::write | ( | SoWriteAction * | action | ) | `[virtual]`

| Action method for SoWriteAction. Writes out a node object, and any connected nodes, engines etc, if necessary. Reimplemented from SoVRMLParent.

void SoVRMLGroup::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoVRMLParent. Reimplemented in SoVRMLTransform.

void SoVRMLGroup::audioRender | ( | SoAudioRenderAction * | action | ) | `[virtual]`

| Action method for SoAudioRenderAction. Does common processing for SoAudioRenderAction action instances. Reimplemented from SoGroup. Reimplemented in SoVRMLTransform.

void SoVRMLGroup::GLRenderBelowPath | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Implements the SoAction::BELOW_PATH traversal method for the rendering action. Reimplemented from SoNode. Reimplemented in SoVRMLTransform.

void SoVRMLGroup::GLRenderInPath | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Implements the SoAction::IN_PATH traversal method for the rendering action. Reimplemented from SoNode. Reimplemented in SoVRMLTransform.

void SoVRMLGroup::GLRenderOffPath | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Implements the SoAction::OFF_PATH traversal method for the rendering action. Reimplemented from SoNode.

void SoVRMLGroup::notify | ( | SoNotList * | list | ) | `[virtual]`

| Notifies all auditors for this instance when changes are made. Reimplemented from SoVRMLParent. Reimplemented in SoVRMLCollision, and SoVRMLTransform.

SbBool SoVRMLGroup::cullTest | ( | SoState * | state | ) | `[protected, virtual]`

| Returns TRUE if children can be culled.

## Member Data Documentation

int SoVRMLGroup::numRenderCaches = 2`[static, protected]`

| SoSFVec3f SoVRMLGroup::bboxSize Can be used to optimize bounding box calculations.

The documentation for this class was generated from the following files:

- SoVRMLGroup.h
- Group.cpp